<template>
	<a-card :bordered="false">
		<a-form ref="searchFormRef" name="advanced_search" :model="searchFormState" class="ant-advanced-search-form mb-4">
			<a-row :gutter="24">
				<a-col :span="4">
					<a-form-item label="企业客户" name="depotId">
						<a-select v-model:value="searchFormState.depotId" placeholder="请选择企业客户" :options="depotOptions" allow-clear/>
					</a-form-item>
				</a-col>
				<a-col :span="4">
					<a-form-item label="放款状态" name="loanState">
						<a-select v-model:value="searchFormState.loanState" placeholder="请选择放款状态" :options="loanStateOptions" allow-clear/>
					</a-form-item>
				</a-col>
				<a-col :span="4">
					<a-form-item label="粮食种类" name="grainGroup">
						<a-select v-model:value="searchFormState.grainGroup" placeholder="请选择粮食种类" :options="grainGroupOptions" allow-clear/>
					</a-form-item>
				</a-col>
				<a-col :span="4">
					<a-form-item label="车牌" name="licensePlate">
						<a-input v-model:value="searchFormState.licensePlate" placeholder="请输入车牌"/>
					</a-form-item>
				</a-col>
				<a-col :span="6">
					<a-button type="primary" @click="table.refresh(true)">查询</a-button>
					<a-button style="margin: 0 8px" @click="() => searchFormRef.resetFields()">重置</a-button>
				</a-col>
			</a-row>
		</a-form>
		<s-table
			ref="table"
			:columns="columns"
			:data="loadData"
			:alert="options.alert.show"
			bordered
			:row-key="(record) => record.id"
			:tool-config="toolConfig"
			:row-selection="options.rowSelection"
		>
			<template #operator class="table-operator">
				<a-space>
					<a-button type="primary" @click="depotLoanGrantFormRef.onOpen(batchDepotLoanOrder())" v-if="hasPerm('depotLoanGrantAdd')">
						<template #icon>
							<plus-outlined/>
						</template>
						放款
					</a-button>
				</a-space>
			</template>
			<template #bodyCell="{ column, record }">
				<template v-if="column.dataIndex === 'action'">
					<a @click="detailFormRef.onOpen(record)">详情</a>
					<!--					<a @click="formRef.onOpen(record)" v-if="hasPerm('depotLoanOrderEdit')">
										<br>
										编辑</a>
									<a-popconfirm title="确定要删除吗？" @confirm="deleteDepotLoanOrder(record)">
										<a-button type="link" danger size="small" v-if="hasPerm('depotLoanOrderDelete')">
											<a-divider type="vertical"/>
											删除
										</a-button>
									</a-popconfirm>-->
				</template>
			</template>
		</s-table>
	</a-card>
	<Form ref="formRef" @successful="table.refresh(true)"/>
	<DetailForm ref="detailFormRef"/>
	<DepotLoanGrantForm ref="depotLoanGrantFormRef" @successful="table.refresh(true)"/>
</template>

<script setup name="depotLoanOrder">
import {message} from 'ant-design-vue'
import tool from '@/utils/tool'
import Form from './form.vue'
import DepotLoanGrantForm from '../depotLoanGrant/form.vue'
import depotLoanOrderApi from '@/api/biz/depotLoanOrderApi'
import depotLoanGrantApi from '@/api/biz/depotLoanGrantApi'
import dictOptionsApi from "@/api/biz/dictOptionsApi";
import DetailForm from './detailForm.vue'

let searchFormState = reactive({"loanState": '待放款'})
const searchFormRef = ref()
const table = ref()
const formRef = ref()
const detailFormRef = ref()
const depotLoanGrantFormRef = ref()
const depotOptions = ref([])
const toolConfig = {refresh: true, height: true, columnSetting: true, striped: false}
const columns = [
	{
		title: '企业客户',
		dataIndex: 'depotGrainName'
	},
	{
		title: '放款状态',
		dataIndex: 'loanState'
	},
	{
		title: '车牌',
		dataIndex: 'licensePlate'
	},
	{
		title: '粮食种类',
		dataIndex: 'grainGroup'
	},
	{
		title: '入库重量(吨)',
		dataIndex: 'dryTonCount'
	},
	{
		title: '入库实际重量(吨)',
		dataIndex: 'depotTonCount'
	},
	{
		title: '入库总金额(元)',
		dataIndex: 'orderAmount'
	},
	{
		title: '质量',
		dataIndex: 'depotQuality'
	},
	{
		title: '入库时间',
		dataIndex: 'createTime',
		width: '150px'
	},
]
// 操作栏通过权限判断是否显示
columns.push({
	title: '操作',
	dataIndex: 'action',
	align: 'center',
	width: '150px'
})
let selectedRowKeys = ref([])
let selectedRowLst = ref([])
// 列表选择配置
const options = {
	alert: {
		show: false,
		clear: () => {
			selectedRowKeys = ref([])
			selectedRowLst = ref([])
		}
	},
	rowSelection: {
		onChange: (selectedRowKey, selectedRows) => {
			selectedRowKeys.value = selectedRowKey
			selectedRowLst.value = selectedRows
		}
	}
}
dictOptionsApi.options(Object.assign('', {'dictValue': '粮库'})).then((data) => {
	depotOptions.value = data
})
const loadData = (parameter) => {
	const searchFormParam = JSON.parse(JSON.stringify(searchFormState))
	return depotLoanOrderApi.depotLoanOrderPage(Object.assign(parameter, searchFormParam)).then((data) => {
		return data
	})
}
// 批量放款
const batchDepotLoanOrder = () => {
	if (selectedRowKeys.value.length < 1) {
		message.warning('请选择一条或多条数据')
		return false
	}
	//重量(吨)/实际重量(吨)/金额/价格/实际价格
	let orderDryWeight = 0, orderWeight = 0, orderAmount = 0, orderDryPrice, orderPrice, grainGroup = new Set()
	let depotIdLst = new Set(selectedRowLst.value.map((m) => {
		grainGroup.add(m.grainGroup)
		orderDryWeight += m.dryTonCount * 1
		orderWeight += m.depotTonCount * 1
		orderAmount += m.orderAmount * 1
		return m.depotId
	}))
	orderDryPrice = (orderAmount / orderDryWeight).toFixed(2)
	orderPrice = (orderAmount / orderWeight).toFixed(2)
	if (depotIdLst.size > 1) {
		message.warning('只能选择一个企业用户')
		return false
	}
	if (grainGroup.size > 1) {
		message.warning('只能选择一种粮食')
		return false
	}
	let workIdLst = selectedRowLst.value.map((m) => {
		return m.id
	})
	return {
		"depotId": Array.from(depotIdLst).toString(),
		"workIdLst": workIdLst,
		"grainGroup": Array.from(grainGroup).toString(),
		"orderDryWeight": orderDryWeight,
		"orderWeight": orderWeight,
		"orderAmount": orderAmount,
		"orderDryPrice": orderDryPrice,
		"orderPrice": orderPrice,
	}
}
const loanStateOptions = tool.dictList('放款状态')
const grainGroupOptions = tool.dictList('粮食种类')
</script>
